import { world, system } from "@minecraft/server"
export class AutoMinerBlock {
    onPlace = ({ block }) => {
        const perm = block.permutation
        const center = block.center();
        const entity_spawn_loc = { x: center.x, y: center.y - 0.5, z: center.z };
        const minerBlocks = [
            "orm:iron_auto_miner",
            "orm:gold_auto_miner",
            "orm:diamond_auto_miner",
            "orm:netherite_auto_miner"
        ]
        if (block.above(1).typeId != "minecraft:air") {
            block.dimension.runCommandAsync(`setblock ${center.x} ${center.y} ${center.z} air destroy`)
            return
        }
        if (minerBlocks.includes(block.below(1).typeId)) {
            return
        }
        if (perm.getState("minecraft:cardinal_direction") === "north") {
            block.dimension.runCommandAsync(`summon ${this.autoMinerID} ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 180 ~`)
        }
        if (perm.getState("minecraft:cardinal_direction") === "south") {
            block.dimension.runCommandAsync(`summon ${this.autoMinerID} ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 0 ~`)
        }
        if (perm.getState("minecraft:cardinal_direction") === "west") {
            block.dimension.runCommandAsync(`summon ${this.autoMinerID} ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} 90 ~`)
        }
        if (perm.getState("minecraft:cardinal_direction") === "east") {
            block.dimension.runCommandAsync(`summon ${this.autoMinerID} ${entity_spawn_loc.x} ${entity_spawn_loc.y} ${entity_spawn_loc.z} -90 ~`)

        }
    }
    onTick = ({ block }) => {
        const center = block.center();
        const entity_loc = { x: center.x, y: center.y - 0.5, z: center.z };
        const cardinalDirection = block.permutation.getState("minecraft:cardinal_direction")
        const melonBlocks = [
            "orm:coal_melon",
            "orm:copper_melon",
            "orm:iron_melon",
            "orm:diamond_melon",
            "orm:lapis_melon",
            "orm:emerald_melon",
            "orm:gold_melon",
            "orm:redstone_melon",
            "orm:netherite_melon"
        ]
        if (block.getRedstonePower() > 0) {
            if (block.permutation.getState("orm:mining") == false) {
                if (cardinalDirection === "north" && melonBlocks.includes(block.north(1).typeId)) {
                    block.dimension.runCommandAsync(`execute positioned ${entity_loc.x} ${entity_loc.y} ${entity_loc.z} run event entity @e[type=${this.autoMinerID},r=0.6] animate`)
                    block.setPermutation(block.permutation.withState("orm:mining", true))
                    system.runTimeout(() => {
                        if (block.north(1).typeId === "orm:coal_melon") {
                            block.north(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.north(1).x} ${block.north(1).y} ${block.north(1).z} loot ${this.coalMelonLoot}`)
                        }
                        if (block.north(1).typeId === "orm:copper_melon") {
                            block.north(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.north(1).x} ${block.north(1).y} ${block.north(1).z} loot ${this.copperMelonLoot}`)
                        }
                        if (block.north(1).typeId === "orm:iron_melon") {
                            block.north(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.north(1).x} ${block.north(1).y} ${block.north(1).z} loot ${this.ironMelonLoot}`)
                        }
                        if (block.north(1).typeId === "orm:gold_melon") {
                            block.north(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.north(1).x} ${block.north(1).y} ${block.north(1).z} loot ${this.goldMelonLoot}`)
                        }
                        if (block.north(1).typeId === "orm:lapis_melon") {
                            block.north(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.north(1).x} ${block.north(1).y} ${block.north(1).z} loot ${this.lapisMelonLoot}`)
                        }
                        if (block.north(1).typeId === "orm:redstone_melon") {
                            block.north(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.north(1).x} ${block.north(1).y} ${block.north(1).z} loot ${this.redstoneMelonLoot}`)
                        }
                        if (block.north(1).typeId === "orm:emerald_melon") {
                            block.north(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.north(1).x} ${block.north(1).y} ${block.north(1).z} loot ${this.emeraldMelonLoot}`)
                        }
                        if (block.north(1).typeId === "orm:diamond_melon") {
                            block.north(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.north(1).x} ${block.north(1).y} ${block.north(1).z} loot ${this.diamondMelonLoot}`)
                        }
                        if (block.north(1).typeId === "orm:netherite_melon") {
                            block.north(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.north(1).x} ${block.north(1).y} ${block.north(1).z} loot ${this.netheriteMelonLoot}`)
                        }
                        block.setPermutation(block.permutation.withState("orm:mining", false))
                    }, 9)
                }
                if (cardinalDirection === "south" && melonBlocks.includes(block.south(1).typeId)) {
                    block.dimension.runCommandAsync(`execute positioned ${entity_loc.x} ${entity_loc.y} ${entity_loc.z} run event entity @e[type=${this.autoMinerID},r=0.6] animate`)
                    block.setPermutation(block.permutation.withState("orm:mining", true))
                    system.runTimeout(() => {
                        if (block.south(1).typeId === "orm:coal_melon") {
                            block.south(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.south(1).x} ${block.south(1).y} ${block.south(1).z} loot ${this.coalMelonLoot}`)
                        }
                        if (block.south(1).typeId === "orm:copper_melon") {
                            block.south(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.south(1).x} ${block.south(1).y} ${block.south(1).z} loot ${this.copperMelonLoot}`)
                        }
                        if (block.south(1).typeId === "orm:iron_melon") {
                            block.south(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.south(1).x} ${block.south(1).y} ${block.south(1).z} loot ${this.ironMelonLoot}`)
                        }
                        if (block.south(1).typeId === "orm:gold_melon") {
                            block.south(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.south(1).x} ${block.south(1).y} ${block.south(1).z} loot ${this.goldMelonLoot}`)
                        }
                        if (block.south(1).typeId === "orm:lapis_melon") {
                            block.south(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.south(1).x} ${block.south(1).y} ${block.south(1).z} loot ${this.lapisMelonLoot}`)
                        }
                        if (block.south(1).typeId === "orm:redstone_melon") {
                            block.south(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.south(1).x} ${block.south(1).y} ${block.south(1).z} loot ${this.redstoneMelonLoot}`)
                        }
                        if (block.south(1).typeId === "orm:emerald_melon") {
                            block.south(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.south(1).x} ${block.south(1).y} ${block.south(1).z} loot ${this.emeraldMelonLoot}`)
                        }
                        if (block.south(1).typeId === "orm:diamond_melon") {
                            block.south(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.south(1).x} ${block.south(1).y} ${block.south(1).z} loot ${this.diamondMelonLoot}`)
                        }
                        if (block.south(1).typeId === "orm:netherite_melon") {
                            block.south(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.south(1).x} ${block.south(1).y} ${block.south(1).z} loot ${this.netheriteMelonLoot}`)
                        }
                        block.setPermutation(block.permutation.withState("orm:mining", false))
                    }, 9)
                }
                if (cardinalDirection === "east" && melonBlocks.includes(block.east(1).typeId)) {
                    block.dimension.runCommandAsync(`execute positioned ${entity_loc.x} ${entity_loc.y} ${entity_loc.z} run event entity @e[type=${this.autoMinerID},r=0.6] animate`)
                    block.setPermutation(block.permutation.withState("orm:mining", true))
                    system.runTimeout(() => {
                        if (block.east(1).typeId === "orm:coal_melon") {
                            block.east(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.east(1).x} ${block.east(1).y} ${block.east(1).z} loot ${this.coalMelonLoot}`)
                        }
                        if (block.east(1).typeId === "orm:copper_melon") {
                            block.east(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.east(1).x} ${block.east(1).y} ${block.east(1).z} loot ${this.copperMelonLoot}`)
                        }
                        if (block.east(1).typeId === "orm:iron_melon") {
                            block.east(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.east(1).x} ${block.east(1).y} ${block.east(1).z} loot ${this.ironMelonLoot}`)
                        }
                        if (block.east(1).typeId === "orm:gold_melon") {
                            block.east(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.east(1).x} ${block.east(1).y} ${block.east(1).z} loot ${this.goldMelonLoot}`)
                        }
                        if (block.east(1).typeId === "orm:lapis_melon") {
                            block.east(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.east(1).x} ${block.east(1).y} ${block.east(1).z} loot ${this.lapisMelonLoot}`)
                        }
                        if (block.east(1).typeId === "orm:redstone_melon") {
                            block.east(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.east(1).x} ${block.east(1).y} ${block.east(1).z} loot ${this.redstoneMelonLoot}`)
                        }
                        if (block.east(1).typeId === "orm:emerald_melon") {
                            block.east(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.east(1).x} ${block.east(1).y} ${block.east(1).z} loot ${this.emeraldMelonLoot}`)
                        }
                        if (block.east(1).typeId === "orm:diamond_melon") {
                            block.east(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.east(1).x} ${block.east(1).y} ${block.east(1).z} loot ${this.diamondMelonLoot}`)
                        }
                        if (block.east(1).typeId === "orm:netherite_melon") {
                            block.east(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.east(1).x} ${block.east(1).y} ${block.east(1).z} loot ${this.netheriteMelonLoot}`)
                        }
                        block.setPermutation(block.permutation.withState("orm:mining", false))
                    }, 9)
                }
                if (cardinalDirection === "west" && melonBlocks.includes(block.west(1).typeId)) {
                    block.dimension.runCommandAsync(`execute positioned ${entity_loc.x} ${entity_loc.y} ${entity_loc.z} run event entity @e[type=${this.autoMinerID},r=0.6] animate`)
                    block.setPermutation(block.permutation.withState("orm:mining", true))
                    system.runTimeout(() => {
                        if (block.west(1).typeId === "orm:coal_melon") {
                            block.west(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.west(1).x} ${block.west(1).y} ${block.west(1).z} loot ${this.coalMelonLoot}`)
                        }
                        if (block.west(1).typeId === "orm:copper_melon") {
                            block.west(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.west(1).x} ${block.west(1).y} ${block.west(1).z} loot ${this.copperMelonLoot}`)
                        }
                        if (block.west(1).typeId === "orm:iron_melon") {
                            block.west(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.west(1).x} ${block.west(1).y} ${block.west(1).z} loot ${this.ironMelonLoot}`)
                        }
                        if (block.west(1).typeId === "orm:gold_melon") {
                            block.west(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.west(1).x} ${block.west(1).y} ${block.west(1).z} loot ${this.goldMelonLoot}`)
                        }
                        if (block.west(1).typeId === "orm:lapis_melon") {
                            block.west(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.west(1).x} ${block.west(1).y} ${block.west(1).z} loot ${this.lapisMelonLoot}`)
                        }
                        if (block.west(1).typeId === "orm:redstone_melon") {
                            block.west(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.west(1).x} ${block.west(1).y} ${block.west(1).z} loot ${this.redstoneMelonLoot}`)
                        }
                        if (block.west(1).typeId === "orm:emerald_melon") {
                            block.west(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.west(1).x} ${block.west(1).y} ${block.west(1).z} loot ${this.emeraldMelonLoot}`)
                        }
                        if (block.west(1).typeId === "orm:diamond_melon") {
                            block.west(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.west(1).x} ${block.west(1).y} ${block.west(1).z} loot ${this.diamondMelonLoot}`)
                        }
                        if (block.west(1).typeId === "orm:netherite_melon") {
                            block.west(1).setType("minecraft:air")
                            block.dimension.runCommandAsync(`loot spawn ${block.west(1).x} ${block.west(1).y} ${block.west(1).z} loot ${this.netheriteMelonLoot}`)
                        }
                        block.setPermutation(block.permutation.withState("orm:mining", false))
                    }, 9)
                }
            }
        }
    }
    autoMinerID;
    coalMelonLoot;
    copperMelonLoot;
    ironMelonLoot;
    goldMelonLoot;
    diamondMelonLoot;
    emeraldMelonLoot;
    lapisMelonLoot;
    redstoneMelonLoot;
    netheriteMelonLoot;
    constructor(autoMinerID, coalMelonLoot, copperMelonLoot, ironMelonLoot, goldMelonLoot, diamondMelonLoot, emeraldMelonLoot, lapisMelonLoot, redstoneMelonLoot, netheriteMelonLoot) {
        this.autoMinerID = autoMinerID;
        this.coalMelonLoot = coalMelonLoot;
        this.copperMelonLoot = copperMelonLoot;
        this.ironMelonLoot = ironMelonLoot;
        this.goldMelonLoot = goldMelonLoot;
        this.diamondMelonLoot = diamondMelonLoot;
        this.emeraldMelonLoot = emeraldMelonLoot;
        this.lapisMelonLoot = lapisMelonLoot;
        this.redstoneMelonLoot = redstoneMelonLoot;
        this.netheriteMelonLoot = netheriteMelonLoot;
    }
}

// world.afterEvents.playerBreakBlock.subscribe((data) => {
//     const { block, dimension, player } = data
//     const cardinalDirection = block.permutation.getState("minecraft:cardinal_direction")
//     block.setPermutation(block.permutation.withState("orm:mining", true));
// })