import { ItemEnchantableComponent, system, world, ItemStack } from "@minecraft/server";
import { BlockManager } from "./Blocks/manager";
import { CropMelonBlock } from "./Custom Farm Blocks/Custom Melon Block/constructor";
import { RedstoneMelon } from "./Custom Farm Blocks/Redstone Melon/constructor";
import { AutoMinerBlock } from "./Auto Miners/constructor";
import "./ore_melons_guide_book"
world.beforeEvents.worldInitialize.subscribe((data) => {
    data.blockComponentRegistry.registerCustomComponent("orm:coal_melon_grow", new CropMelonBlock("orm:growth_stage", "orm:connected", "orm:connected_side", 3, { numerator: 1, denominator: 3 }, "orm:coal_melon", true));
    data.blockComponentRegistry.registerCustomComponent("orm:copper_melon_grow", new CropMelonBlock("orm:growth_stage", "orm:connected", "orm:connected_side", 3, { numerator: 1, denominator: 3 }, "orm:copper_melon", true));
    data.blockComponentRegistry.registerCustomComponent("orm:iron_melon_grow", new CropMelonBlock("orm:growth_stage", "orm:connected", "orm:connected_side", 3, { numerator: 1, denominator: 3 }, "orm:iron_melon", true));
    data.blockComponentRegistry.registerCustomComponent("orm:gold_melon_grow", new CropMelonBlock("orm:growth_stage", "orm:connected", "orm:connected_side", 3, { numerator: 1, denominator: 3 }, "orm:gold_melon", true));
    data.blockComponentRegistry.registerCustomComponent("orm:redstone_melon_grow", new CropMelonBlock("orm:growth_stage", "orm:connected", "orm:connected_side", 3, { numerator: 1, denominator: 3 }, "orm:redstone_melon", true));
    data.blockComponentRegistry.registerCustomComponent("orm:lapis_melon_grow", new CropMelonBlock("orm:growth_stage", "orm:connected", "orm:connected_side", 3, { numerator: 1, denominator: 3 }, "orm:lapis_melon", true));
    data.blockComponentRegistry.registerCustomComponent("orm:diamond_melon_grow", new CropMelonBlock("orm:growth_stage", "orm:connected", "orm:connected_side", 3, { numerator: 1, denominator: 3 }, "orm:diamond_melon", true));
    data.blockComponentRegistry.registerCustomComponent("orm:emerald_melon_grow", new CropMelonBlock("orm:growth_stage", "orm:connected", "orm:connected_side", 3, { numerator: 1, denominator: 3 }, "orm:emerald_melon", true));
    data.blockComponentRegistry.registerCustomComponent("orm:netherite_melon_grow", new CropMelonBlock("orm:growth_stage", "orm:connected", "orm:connected_side", 3, { numerator: 1, denominator: 3 }, "orm:netherite_melon", true));
    data.blockComponentRegistry.registerCustomComponent("orm:redstone_melon_particles", new RedstoneMelon);
    data.blockComponentRegistry.registerCustomComponent("orm:iron_autominer_comp", new AutoMinerBlock("orm:iron_auto_miner_entity", "coal_melon_auto_miner_1_loot", "copper_melon_auto_miner_1_loot", "iron_melon_auto_miner_1_loot", "gold_melon_auto_miner_1_loot", "diamond_melon_auto_miner_1_loot", "emerald_melon_auto_miner_1_loot", "lapis_melon_auto_miner_1_loot", "redstone_melon_auto_miner_1_loot", "netherite_melon_auto_miner_1_loot"));
    data.blockComponentRegistry.registerCustomComponent("orm:gold_autominer_comp", new AutoMinerBlock("orm:gold_auto_miner_entity", "coal_melon_auto_miner_2_loot", "copper_melon_auto_miner_2_loot", "iron_melon_auto_miner_2_loot", "gold_melon_auto_miner_2_loot", "diamond_melon_auto_miner_2_loot", "emerald_melon_auto_miner_2_loot", "lapis_melon_auto_miner_2_loot", "redstone_melon_auto_miner_2_loot", "netherite_melon_auto_miner_2_loot"));
    data.blockComponentRegistry.registerCustomComponent("orm:diamond_autominer_comp", new AutoMinerBlock("orm:diamond_auto_miner_entity", "coal_melon_auto_miner_3_loot", "copper_melon_auto_miner_3_loot", "iron_melon_auto_miner_3_loot", "gold_melon_auto_miner_3_loot", "diamond_melon_auto_miner_3_loot", "emerald_melon_auto_miner_3_loot", "lapis_melon_auto_miner_3_loot", "redstone_melon_auto_miner_3_loot", "netherite_melon_auto_miner_3_loot"));
    data.blockComponentRegistry.registerCustomComponent("orm:netherite_autominer_comp", new AutoMinerBlock("orm:netherite_auto_miner_entity", "coal_melon_auto_miner_4_loot", "copper_melon_auto_miner_4_loot", "iron_melon_auto_miner_4_loot", "gold_melon_auto_miner_4_loot", "diamond_melon_auto_miner_4_loot", "emerald_melon_auto_miner_4_loot", "lapis_melon_auto_miner_4_loot", "redstone_melon_auto_miner_4_loot", "netherite_melon_auto_miner_4_loot"));
});

world.beforeEvents.playerBreakBlock.subscribe((data) => {
    const { block, itemStack, dimension } = data;
    if (!block.hasTag("orm:disable_silk_touch"))
        return;
    if (!itemStack)
        return;
    const comp = itemStack.getComponent(ItemEnchantableComponent.componentId);
    if (!comp)
        return;
    if (!comp.hasEnchantment("silk_touch"))
        return;
    data.cancel = true;
    system.runTimeout(() => {
        BlockManager.destroyBlock(dimension, block.location);
    });
});

world.afterEvents.playerPlaceBlock.subscribe((data) => {
    const { block } = data
    const center = block.center();
    const minerBlocks = [
        "orm:iron_auto_miner",
        "orm:gold_auto_miner",
        "orm:diamond_auto_miner",
        "orm:netherite_auto_miner"
    ]
    if (block.typeId === "minecraft:redstone_wire") {
        return
    }
    if (minerBlocks.includes(block.below(1).typeId)) {
        block.dimension.runCommandAsync(`setblock ${center.x} ${center.y} ${center.z} air destroy`)
    }
})

world.afterEvents.playerSpawn.subscribe((data) => {
    const intialSpawn = data.initialSpawn
    const player = data.player
    const joinTag = player.getDynamicProperty("orm:join")
    if (intialSpawn && joinTag === undefined) {
        player.setDynamicProperty("orm:join", true)
        player.dimension.spawnItem(new ItemStack('orm:ore_melons_guide_book', 1), player.location);
    }
})