import { world } from "@minecraft/server"
import { ActionFormData } from "@minecraft/server-ui"

class BookMenus {
    MainMenu(player) {
        const form = new ActionFormData()
            .title(`Ore Melons Guide Book`)
            .button("Ore Melon Plants", "textures/blocks/diamond_melon")
            .button("Ore Melon Seeds", "textures/items/diamond_melon_seed")
            .button("Auto Miners", "textures/blocks/diamond_auto_miner")

        form.show(player).then((data) => {
            if (data.selection === 0) {
                BookMenu.OreMelonsMenu(player)
                player.runCommandAsync(`playsound item.book.page_turn @s ~ ~ ~ 1 1 1`)
            }
            if (data.selection === 1) {
                BookMenu.OreMelonSeedsMenu(player)
                player.runCommandAsync(`playsound item.book.page_turn @s ~ ~ ~ 1 1 1`)
            }
            if (data.selection === 2) {
                BookMenu.AutoMinersMenu(player)
                player.runCommandAsync(`playsound item.book.page_turn @s ~ ~ ~ 1 1 1`)
            }
            if (data.canceled) {
                player.runCommandAsync(`playsound item.book.put @s ~ ~ ~ 1 1 1`)
            }
        })
    }
    OreMelonsMenu(player) {
        const form = new ActionFormData()
            .title(`Ore Melon Plants Info`)
            .body("Use ore melon seeds on farmland to plant ore melon plants.\n\nAlso, ore melon plants can be bonemealed until an ore melon grows, and ore melons grow back after harvesting!\n\nYou will need a stone pickaxe or higher to mine coal/copper/iron/ ore melons, an iron pickaxe or higher to mine gold/lapis/redstone/emerald/diamond ore melons, and a diamond pickaxe or higher to mine netherite ore melons.")
            .button("Main Menu", "textures/items/ore_melons_guide_book")

        form.show(player).then((data) => {
            if (data.selection === 0) {
                BookMenu.MainMenu(player)
                player.runCommandAsync(`playsound item.book.page_turn @s ~ ~ ~ 1 1 1`)
            }
        })
    }
    OreMelonSeedsMenu(player) {
        const form = new ActionFormData()
            .title(`Ore Melon Seeds Info`)
            .body("Ore melon seeds are crafted by placing melon seeds in the middle of the crafting grid and placing the ore drop item on top/bottom/left/right grid spaces.")
            .button("Main Menu", "textures/items/ore_melons_guide_book")

        form.show(player).then((data) => {
            if (data.selection === 0) {
                BookMenu.MainMenu(player)
                player.runCommandAsync(`playsound item.book.page_turn @s ~ ~ ~ 1 1 1`)
            }
        })
    }
    AutoMinersMenu(player) {
        const form = new ActionFormData()
            .title(`Auto Miners Info`)
            .body("Auto miners come in 4 tier levels and require redstone to function. The autominers must also be placed facing the ore melons to mine them the same way you would place an observer facing a block to detect changes.\n\nLevel 1: Iron\n\nThe iron autominer is crafted with iron pickaxe/observer/iron ingot and drops 1 to 2 ore drop items and 0 to 1 melon seeds\n\nLevel 2: Gold\n\nThe gold autominer is crafted with golden pickaxe/iron autominer/gold ingot and drops 3 to 4 ore drop items and 1 to 2 melon seeds\n\nLevel 3: Diamond\n\nThe diamond autominer is crafted with diamond pickaxe/gold autominer/diamond and drops 5 to 7 ore drop items and 2 to 3 melon seeds\n\nLevel 4: Netherite\n\nThe netherite autominer is crafted with netherite pickaxe/diamond autominer/netherite ingot and drops 8 to 10 ore drop items and 4 to 5 melon seeds")
            .button("Main Menu", "textures/items/ore_melons_guide_book")

        form.show(player).then((data) => {
            if (data.selection === 0) {
                BookMenu.MainMenu(player)
                player.runCommandAsync(`playsound item.book.page_turn @s ~ ~ ~ 1 1 1`)
            }
        })
    }
}
export const BookMenu = new BookMenus

world.afterEvents.itemUse.subscribe((data) => {
    const player = data.source
    if (data.itemStack.typeId === "orm:ore_melons_guide_book") {
        BookMenu.MainMenu(player)
        player?.playSound("item.book.page_turn")
    }
})